<template>
  <div class="section" :style="{ background }">
    <div
      class="contentWrapper"
      :style="{
        '--max_content_width': `${content_width}px`,
        flexDirection: revert ? 'row-reverse' : 'row',
      }"
    >
      <div
        class="textWrapper"
        :style="{
          flex: 1 - image_width,
          marginRight: revert ? 0 : content_gap,
        }"
      >
        <span class="title" :style="{ color: titleColor }" v-if="title">{{
          title
        }}</span>
        <span
          class="subtitle"
          :style="{ color: subtitleColor }"
          v-if="subtitle"
          >{{ subtitle }}</span
        >
        <p
          class="text"
          v-if="text"
          :style="{ color: textColor }"
          v-html="text"
        />
      </div>

      <div
        class="imageWrapper"
        :style="{
          '--aspect-ratio': aspect_ratio,
          flex: image_width,
          marginRight: revert ? content_gap : 0,
        }"
      >
        <img :src="image_src" alt="" srcset="" />
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "TextWithImage_1",
  label: "Текст с картинкой (v1)",
  image: "TextWImage_1",
  props: {
    title: {
      type: String,
      editType: "String",
      init_val: "Title",
      group: "Содержимое",
      label: "Заголовок",
    },
    subtitle: {
      type: String,
      editType: "String",
      init_val: "Subtite",
      group: "Содержимое",
      label: "Подзаголовок",
    },
    text: {
      type: String,
      editType: "HtmlText",
      label: "Подпись",
      group: "Содержимое",
      init_val:
        "Разнообразный и богатый опыт постоянное информационно-пропагандистское обеспечение нашей деятельности представляет собой интересный эксперимент проверки системы обучения кадров, соответствует насущным потребностям. Разнообразный и богатый опыт консультация с широким активом позволяет выполнять важные задания по разработке существенных финансовых и административных условий.",
    },
    image_src: {
      type: String,
      editType: "String",
      init_val: "https://picsum.photos/1024/1024",
      group: "Изображение",
      label: "Путь до изображения",
    },
    aspect_ratio: {
      type: String,
      editType: "String",
      init_val: "1/1",
      group: "Изображение",
      label: "Соотношение сторон",
    },
    image_width: {
      type: String,
      editType: "String",
      group: "Макет",
      label: "Ширина картинки",
      init_val: "0.4",
    },
    content_gap: {
      type: String,
      editType: "String",
      group: "Макет",
      label: "Отступ",
      init_val: "15%",
    },
    content_width: {
      type: Number,
      editType: "String",
      group: "Макет",
      label: "Максимальная ширина контента",
      init_val: 960,
    },
    revert: {
      type: Boolean,
      editType: "Boolean",
      group: "Макет",
      label: "Картинка слева?",
      init_val: false,
    },
    background: {
      type: String,
      editType: "String",
      init_val: "#F4F5F7",
      label: "Фон",
      group: "Палитра",
    },
    titleColor: {
      type: String,
      editType: "String",
      init_val: "#000000",
      label: "Заголовок",
      group: "Палитра",
    },
    subtitleColor: {
      type: String,
      editType: "String",
      init_val: "#000000",
      label: "Подзаголовок",
      group: "Палитра",
    },
    textColor: {
      type: String,
      editType: "String",
      init_val: "#000000",
      label: "Подпись",
      group: "Палитра",
    },
  },
};
</script>

<style scoped lang="scss">
.section {
  background: #f4f5f7;
  padding: 60px 20px;
  width: 100%;
  height: auto;

  @media screen and (max-width: 480px) {
    padding: 24px 16px;
  }
}

.contentWrapper {
  display: flex;
  max-width: var(--max_content_width);
  margin: 0 auto;
  justify-content: space-between;

  .imageWrapper {
    flex: 0.4;
    background: #c4c4c4;
    border-radius: 4px;
    overflow: hidden;
    position: relative;
    transition: 0.3s ease all;
    height: min-content;

    &::before {
      content: "";
      display: block;
      padding-bottom: calc(100% / (var(--aspect-ratio)));
    }

    img {
      position: absolute;
      height: 100%;
      width: 100%;
      top: 0;
      left: 0;
      right: 0;
      bottom: 0;
      object-fit: cover;
      display: block;
    }
  }

  .textWrapper {
    flex: 0.5;
    display: block;
    .title {
      display: block;
      font-family: "Rubik";
      font-weight: normal;
      font-size: 18px;
      line-height: 21px;
      color: #000000;
      margin-top: 5px;
    }
    .subtitle {
      display: block;
      font-family: "Rubik";
      font-weight: 500;
      font-size: 36px;
      line-height: 43px;
      color: #000000;
      margin-top: 5px;
    }
    .text {
      display: block;
      margin-top: 5px;
      font-size: 14px;
    }

    > *:first-child {
      margin-top: 0;
    }
  }

  @media screen and (max-width: 768px) {
    flex-direction: column !important;
    align-items: center;
    .textWrapper {
      width: 100%;
      padding-right: 0 !important;
      margin-right: 0 !important;
    }
    .imageWrapper {
      margin-top: 40px;
      width: 50%;
      margin-right: 0 !important;
    }
  }

  @media screen and (max-width: 480px) {
    .textWrapper {
      width: 100%;
    }
    .imageWrapper {
      margin-top: 40px;
      width: 100%;
      align-self: center;
    }
  }
}
</style>
